"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const path = require('path');
const utils = require('@vue/cli-shared-utils');
const exeRootPath = process.cwd();
const pluginRootPath = path.resolve(__dirname, '../../../');
const log = require("../../utils/log");
const R = require('ramda');
const constant = require('../../constant');
module.exports = (api) => (args) => __awaiter(void 0, void 0, void 0, function* () {
    const config = api.resolveWebpackConfig();
    const platform = args.platform;
    const command = require(`@mand-mobile/platform/src/${platform}/builder/command/build`);
    const vueCliService = require.resolve('@vue/cli-service/bin/vue-cli-service', {
        // 从当前执行环境下解析vueCli
        paths: [
            exeRootPath,
        ]
    });
    api.mdContext = Object.assign({}, args.mdContext, {
        vueCliService,
        exeRootPath,
        pluginRootPath,
        MAND_PLATFORM: platform,
        webpackConfig: config,
        MAND_BUILD_TARGET: args.target,
        MAND_INPUT_DIR: process.env.MAND_INPUT_DIR || '.mand-mobile',
        MAND_OUTPUT_DIR: process.env.MAND_OUTPUT_DIR || 'dist'
    });
    api.mdUtils = Object.assign({}, args.mdUtils, utils);
    return command(args, api);
    // if (args.target === constant.BUILD_TARGET_BUNDLE  && args.platform === constant.PLATFORM_WEB) {
    //   // console.log(config)
    //   const run = R.compose(generate, translateToRollupConfig)
    //   await run({webpackConfig: config, entry: args._})
    //   log.info('h5 bundle was called')
    // }
    // if (args.target === constant.BUILD_TARGET_LIB && args.platform === constant.PLATFORM_WEB) {
    //   log.info('h5 lib was called')
    //   // getComponets()
    //   compileVueSFC()
    // }
});
//# sourceMappingURL=index.js.map