"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
/**
 * 找不到@vue/cli的相关类型 暂时any-script过渡一下
 */
const ramda_1 = __importDefault(require("ramda"));
const path = __importStar(require("path"));
// import WebpackChain from 'webpack-chain/types'
const commands = ['md-build', 'md-serve'];
function addStyleResource(rule) {
    const mandMobileSharedRoot = path.dirname(require.resolve('@mand-mobile/shared'));
    /**
     * @todo add nib style-resources
     */
    rule.use('style-resource')
        .loader('style-resources-loader')
        .options({
        patterns: [
            path.join(mandMobileSharedRoot, 'lib/style/mixin/theme.basic.styl'),
            path.join(mandMobileSharedRoot, 'lib/style/mixin/theme.components.styl'),
            path.join(mandMobileSharedRoot, 'lib/style/mixin/util.styl'),
        ],
    });
}
function addPostcssConfig(rule) {
    rule
        .use('postcss-loader')
        .loader('postcss-loader')
        .tap((options) => {
        options.plugins = options.plugins || [];
        options.plugins.push(require('postcss-url')({ url: 'inline' }));
        options.plugins.push(require('postcss-pxtorem')({ rootValue: 100, minPixelValue: 2, propWhiteList: [] }));
        options.plugins.push(require('cssnano')({
            preset: ['default', {
                    zindex: false,
                    mergeIdents: false,
                    discardUnused: false,
                    autoprefixer: false,
                    reduceIdents: false,
                }]
        }));
        return options;
    });
}
module.exports = (api, projectOptions) => {
    api.chainWebpack((chainConfig) => {
        // 通过 webpack-chain 修改 webpack 配置
        // console.info('chainwebpackConfig', webpackConfig)
        const types = ['vue-modules', 'vue', 'normal-modules', 'normal'];
        ramda_1.default.forEach(type => addStyleResource(chainConfig.module.rule('stylus').oneOf(type)), types);
        ramda_1.default.forEach(type => addPostcssConfig(chainConfig.module.rule('postcss').oneOf(type)), types);
    });
    api.configureWebpack((webpackConfig) => {
        // console.info('webpackConfig', webpackConfig)
    });
    ramda_1.default.forEach((command) => {
        const handler = require(path.resolve(__dirname, `commands/${command}`));
        api.registerCommand(command, handler(api));
    }, commands);
};
//# sourceMappingURL=index.js.map